function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import isPlainObject from 'lodash.isplainobject';
export class FSProperties {
  constructor(properties) {
    _defineProperty(this, "properties", {});
    this.initialize(properties);
  }
  initialize(properties) {
    this.properties = {};
    const stack = [properties];
    while (!!stack.length) {
      const nextElement = stack.shift();
      if (nextElement === null || nextElement === undefined) continue;
      for (const key in nextElement) {
        if (isPlainObject(nextElement[key])) {
          const innerObject = nextElement[key];
          for (const k in innerObject) {
            const concatenatedKey = key + '.' + k;
            stack.push({
              [concatenatedKey]: innerObject[k]
            });
          }
        } else if (Array.isArray(nextElement[key])) {
          for (const item of nextElement[key]) {
            stack.push({
              [key]: item
            });
          }
        } else {
          this.addSimpleObject(key, nextElement[key]);
        }
      }
    }
  }
  addSimpleObject(key, obj) {
    if (!!this.properties[key]) {
      if (Array.isArray(this.properties[key])) {
        this.properties[key].push(obj);
      } else {
        this.properties[key] = [this.properties[key], obj];
      }
    } else {
      this.properties[key] = obj;
    }
  }
  getProperties() {
    return this.properties;
  }
}
//# sourceMappingURL=FSProperties.js.map